.module                 ADSR;

{ Yo, this is an envelope generator!  And that's def!  Yo! }

.global do_adsr;

.var/dm/ram countdown;
.init countdown: 0x0001;

{ set i0 to start of struct.  destroys i0,l0,m0, ax1,ax0,ar,af,ay1,ay0 }
{ amplitude returned in ar                                 }
{ data structure looks like this:                          }
{ [ state ] [ amp ] [ A ] [ D ] [ S ] [ R ]                }            
{ 0 = idle    }
{ 1 = attack  }
{ 2 = decay   }
{ 3 = sustain }
{ 4 = release }

do_adsr:
        { check countdown...only update every 256 cycles }
        ax1 = dm(countdown);
        ay1 = 0x0001;
        ar  = ax1-ay1;
        dm(countdown)=ar;
        if eq jump reset_countdown;

        { return amp in ar anyway }
        l0  = 0;
        m0  = 1;
        ax1 = dm(i0,m0);        { read state }
        ax1 = dm(i0,m0);        { read amp }
        ar  = ax1;
        rts;

reset_countdown:
        ax1 = 0x0100;
        dm(countdown)=ax1;

okay_adsr:
        l0  = 0;
        m0  = 1;
        ax1 = dm(i0,m0);        { read state }

        { do whatever based on state }
        ay1 = 1;none = ax1 - ay1;if eq jump adsr_attack;
        ay1 = 2;none = ax1 - ay1;if eq jump adsr_decay;
        ay1 = 3;none = ax1 - ay1;if eq jump adsr_sustain;
        ay1 = 4;none = ax1 - ay1;if eq jump adsr_release;

        m0  = -1;               { idle, or set to idle }
        ax1 = dm(i0,m0);
        ax1 = 0;
        dm(i0,m0) = 0;

        ar  = 0;                { return no amplitude }
        rts;

adsr_attack:
        ax0 = dm(i0,m0);        { read amplitude }
        m0  = -1;
        ay0 = dm(i0,m0);        { get attack rate }
        ar  = ax0 + ay0;        { compute new amplitude }
        m0  = 0;
        dm(i0,m0) = ar;         { save new amplitude }

        if not av rts;          { not reached amplitude peak yet }

        ax1 = 0x7fff;   
        m0  = -1;
        dm(i0,m0) = ax1;        { reset amplitude to maximum }
        ar  = ax1;

        ax1 = 2;                { set state to decay }
        dm(i0,m0) = ax1;

        rts;                    { done }


adsr_decay:
        m0  = 2;
        ax0 = dm(i0,m0);        { read amplitude }
        m0  = -2;
        ay0 = dm(i0,m0);        { get decay rate }
        ar  = ax0 - ay0;        { compute new amplitude }

        m0  = 3;
        dm(i0,m0) = ar;         { save new amplitude }
        m0  = -3;
        ay0 = dm(i0,m0);        { get sustain }
        af  = ar - ay0;
        if ac rts;              { done }

        m0  = -1;
        dm(i0,m0) = ay0;        { reset amplitude to maximum }
        ar  = ay0;

        ax1 = 3;                { set state to sustain }
        dm(i0,m0) = ax1;

        rts;                    { done }


{ dont do anything until you receive a note off }
adsr_sustain:
        ax1 = dm(i0,m0);
        ar  = ax1;
        rts;

adsr_release:
        m0  = 4;
        ax0 = dm(i0,m0);        { read amplitude }
        m0  = -4;
        ay0 = dm(i0,m0);        { get release rate }
        ar  = ax0 - ay0;
        m0  = 0;
        dm(i0,m0) = ar;         { save new amplitude }

        if gt rts;              { done }

        ax1 = 0;
        m0  = -1;
        dm(i0,m0) = ax1;        { set amplitude to zero }
        ar  = ax1;

        dm(i0,m0) = ax1;        { set state to idle }
        rts;

.endmod;



