.module SAMP;

.include <system.k>;

.global do_samp;
.global newsound,killsound;
.global synth_cont;

.var/dm/ram voice_data[16]; { [vol][delta][lo][hi] - playing data }
.init voice_data[ 0]:0x0000,0x0000,0x0000,0x0000;
.init voice_data[ 4]:0x0000,0x0000,0x0000,0x0000;
.init voice_data[ 8]:0x0000,0x0000,0x0000,0x0000;
.init voice_data[12]:0x0000,0x0000,0x0000,0x0000;

.var voice_ptr[4];
.init voice_ptr: ^voice_data,^voice_data+4,^voice_data+8,^voice_data+12;

.var voice_init_data[8]; { [start lo][start hi] }
.init voice_init_data[0]:0x8828,0x0000;
.init voice_init_data[2]:0x9620,0x0000;
.init voice_init_data[4]:0xa1ba,0x0000;
.init voice_init_data[6]:0xb9c1,0x0000;

.var d_byte;

.var special;
.var fish1,fish2,printme,debugnum,fish3,fish4;
.var fish5,fish6,fish7,fish8,fish0;
.var tempchan;
.external nSend;

.include <freqtab.h>;   { frequency table }

do_samp:

samp_setup:
        i0  = ^voice_data;
        l0  = 0;
        m0  = 0;
        m1  = 1;
        mr  = 0;

        ay0 = 0xfc00;   { for masking off bits later }

        cntr = 4;               { 4 voices }
        do whole_samp_loop until ce;

start_samp_loop:
        ar  = ^d_byte;          { for returning dma-read samples }
        dm(BDMA_BIAD) = ar;     


        my0 = dm(i0,m1);   { get already-scaled volume }

        ay1 = dm(i0,m1);   { get wave_delta   }
        
        ar  = dm(i0,m0);        { read wave_addr_lo }
        sr  = lshift ar by -12(lo);     { lowest part of BDMA_BEAD }
        ar  = ar + ay1;         { increment wave_addr_lo }
        dm(i0,m1) = ar;         { store wave_addr_lo }
        dm(special) = ar;       { debug }

        ar  = dm(i0,m0);   { read wave_addr_hi }
        if av ar = ar + 1; { increment address hi }
        dm(i0,m1) = ar;    { store wave_addr_hi }

        
assemble_addr:
        sr  = sr or lshift ar by 4(lo);
        dm(BDMA_BEAD) = sr0;             { write addr part }

        ar  = ar and ay0;               { mask off lower 10 bits }
        sr  = lshift ar by -2(lo);
        ar  = sr0 or 2;                 { BTYPE = b10 return byte into MSB }
        dm(BDMA_BDMA_Ctrl) = ar;        { compute low part }

	ar  = 0x0001;
        dm(BDMA_BWCOUNT) = ar;          { kick it off }
        idle;                           { wait for bdma int }

        ar  = dm(d_byte);               { get sample data }
        {none = pass ar;}
        {if eq call sample_end;}
        {ar  = dm(special); }       { debug }
        {my0 = 0x1fff; }
whole_samp_loop:
        mr  = mr + ar*my0(ss);         { accumulate them, amplitude scale }
        rts;

sample_end: { loop or kill sample }
kill_sample:
                rts;   
        
        ar  = i0;               { point back to voice volume }
        ar  = ar -4;    
        i1  = ar;
        l1  = 0;
        ar  = 0;
        dm(i1,m1) = ar;         { clear voice's volume }
        dm(i1,m1) = ar;         { clear voice's delta }
        rts;


{ Use MIDI note number to set sample pitch ---------------------------- }
newsound:
        { ay0 = dm(midi_ch);  }
        { ay1 = dm(note_num); }
        { ax1 = dm(midi_vel); }
        { l0  = 0;            }
        l0  = 0;
        m0  = 0;
        m1  = 1;

        ar  = ax1;              { use velocity info }
        sr  = lshift ar by 6(lo);  { midi_vel << 8, div by 4 voices }
        ax1 = sr0;              { scaled velocity }

        ar  = ^freqtab;         { compute delta using note_num }
        ar  = ar + ay1;
        ay1 = 0x0018;           { shift range if you want }
        ar  = ar - ay1;
        i0  = ar;

        ay1 = dm(i0,m1);        { read 16-bit delta }

{ remember: [vol][delta][lo][hi] }

        ar  = ^voice_ptr;    { point to voice play data }
        ar  = ar + ay0;         { ay0 is channel }
        i0  = ar;
        ar  = dm(i0,m1);        { dereference }
        i0  = ar;

        dm(fish0)=i0;

        ar = dm(i0,m0);dm(fish1)=i0;    { read old velo }
        dm(i0,m0) = ax1;        { store scaled velocity }
        ar = dm(i0,m1);dm(fish2)=ar;    { read newly stored velo }
 
        ar = dm(i0,m0);dm(fish3)=i0;    { read old delta }
        dm(i0,m1) = ay1;        { store scaled 16-bit delta }
        dm(fish4) = ay1;

        ar  = ^voice_init_data;      { point to voice init data }
        ar  = ar + ay0;         { ay0 is channel }
        ar  = ar + ay0;
        i1  = ar;
        l1  = 0;

        dm(fish2)=i1;
        ax0 = dm(i1,m1);        { get init wave lo }
        dm(fish4)=i1;
        ax1 = dm(i1,m0);        { get init wave hi }

        { /// begin temporary bug fix //// }

        jump skiptempbugfix;

        ay0 = 0x810;
        ar  = ax0 + ay0;
        ax0 = ar;

        ar  = ax1;
        if av ar = ar + 1;
        ax1 = ar;

skiptempbugfix:

        { /// end temporary bug fix //// }

        ar  = dm(i0,m0);
        dm(fish5) = i0;
        dm(i0,m1)=ax0;          { store init wave lo }

        dm(fish7) = ax0;

        ar  = dm(i0,m0);
        dm(fish6) = i0;
        dm(i0,m0)=ax1;          { store init wave hi }
        dm(fish8) = ax1;


        ax1=dm(fish0);dm(printme)=ax1;ax1=0;dm(tempchan)=ax1;call nprintme;
        ax1=dm(fish1);dm(printme)=ax1;ax1=1;dm(tempchan)=ax1;call nprintme;
        ax1=dm(fish2);dm(printme)=ax1;ax1=2;dm(tempchan)=ax1;call nprintme;
        ax1=dm(fish3);dm(printme)=ax1;ax1=3;dm(tempchan)=ax1;call nprintme;
        ax1=dm(fish4);dm(printme)=ax1;ax1=4;dm(tempchan)=ax1;call nprintme;
        ax1=dm(fish5);dm(printme)=ax1;ax1=5;dm(tempchan)=ax1;call nprintme;
        ax1=dm(fish7);dm(printme)=ax1;ax1=7;dm(tempchan)=ax1;call nprintme;
        ax1=dm(fish6);dm(printme)=ax1;ax1=6;dm(tempchan)=ax1;call nprintme;
        ax1=dm(fish8);dm(printme)=ax1;ax1=8;dm(tempchan)=ax1;call nprintme;

        rts;

nprintme:
        {rts;}
        ar  = 0x00b0;
        ay1 = dm(tempchan);
        ar  = ar + ay1;
        ax1 = ar;call nSend;

        ay1 = 0x000f;
        mr0 = dm(printme);
        sr  = lshift mr0 by -12(lo);
        ar  = sr0 and ay1;                
        ax1 = ar; call nSend;

        ay1 = 0x000f;
        mr0 = dm(printme);
        sr  = lshift mr0 by -8(lo);
        ar  = sr0 and ay1;                
        ax1 = ar; call nSend;


        ar  = 0x00b0;
        ay1 = dm(tempchan);
        ar  = ar + ay1;
        ax1 = ar;call nSend;

        ay1 = 0x000f;
        mr0 = dm(printme);
        sr  = lshift mr0 by -4(lo);
        ar  = sr0 and ay1;                
        ax1 = ar; call nSend;

        ay1 = 0x000f;
        mr0 = dm(printme);
        sr  = lshift mr0 by 0(lo);
        ar  = sr0 and ay1;                
        ax1 = ar; call nSend;

        rts;

{ note off: null volume to disable sound ---------------------------------- }
killsound:
        {rts; }           { stop the killing! }

        ar  = ^voice_ptr;    { point to voice play data }
        ar  = ar + ay0;         { ay0 is channel }
        i1  = ar;
        l1  = 0;
        ar  = dm(i1,m0);
        i1  = ar;
        m1  = 1;

        ax1 = 0;
        dm(i1,m1) = ax1;        { zero volume for this channel }
        dm(i1,m0) = ax1;        { zero delta for this channel }

        rts;


{ process MIDI controllers ------------------------------------------- }
synth_cont:             

        { ax0 = midi_val, ax1 = midi_cont }
        ay1 =  1;none = ax1-ay1;if eq jump set_wavea;

        { if controller number not matched, do nothing }
        jump end_synth_cont;

set_wavea:

        jump end_synth_cont;

set_return_to_mon:                      { if value is "off" 0-63 }
        rts;

end_synth_cont:
        rts;


.endmod;
