.module/RAM/ABS=0       INITME;

.include <system.k>;
.include <samp.k>;

.global nSend;

.var return_to_mon,calc_another;
.init return_to_mon:0x0000;
.init calc_another:0x1;

{ synth functions }
.external process_midi;
.external inputmidi;
                                     
{ Variables }

.var/dm/ram signon [11];
.init signon:
'S','a','m','p',' ','0','.','1',0;

.var input1, input2, output1, output2;
.var synthout1,synthout2;

.var/dm/ram/circ                rx_buf[3];      { Status + L data + R data }
.var/dm/ram/circ                tx_buf[3];      { Cmd + L data + R data    }
.var/dm/ram/circ                init_cmds[13];
.var/dm                         stat_flag;

{ init data }

.init tx_buf:   0xc000, 0x0000, 0x0000; { Initially set MCE        }
.init init_cmds:0xc002,0xc102,0xc288,0xc388,0xc488,0xc588,0xc680,0xc780,
                0xc85b,0xc909,0xca00,0xcc40,0xcd00;
                { c85b for 44 KHz sample rate }

{ Interrupt vector table }
        jump start;  rti; rti; rti;     {00: reset }
        rti;         rti; rti; rti;     {04: IRQ2 }
        rti;         rti; rti; rti;     {08: IRQL1 }
        rti;         rti; rti; rti;     {0c: IRQL0 }
        ar = dm(stat_flag);             {10: SPORT0 tx (Codec) }
        ar = pass ar;
        if eq rti;
        jump next_cmd;
        jump input_samples;             {14: SPORT1 rx (Codec) }
                     rti; rti; rti;
        rti;         rti; rti; rti;     {18: IRQE }
        rti;         rti; rti; rti;     {1c: BDMA }
        jump irq1isr;rti; rti; rti;     {20: SPORT1 tx or IRQ1 }
        rti;         rti; rti; rti;     {24: SPORT1 rx or IRQ0 }
        rti;         rti; rti; rti;     {28: timer }
        rti;         rti; rti; rti;     {2c: power down }


{ ADSP 2181 intialization }

start:
        m7 = 0;
        l7 = 0;
        ax0 = b#0000100000000000;
        dm (System_Control_Reg) = ax0;          { shut down sport 0 }

        i7 = 0x3fe8;            { restore monitor timer handler }
        ar = pm (i7, m7);       { px implicit }
        i7 = 0x28;
        pm (i7, m7) = ar;

        i5 = ^rx_buf;l5 = %rx_buf;
        i6 = ^tx_buf;l6 = %tx_buf;
        i3 = ^init_cmds;l3 = %init_cmds;
        m1 = 1;m5 = 1;

{================== S E R I A L   P O R T   #0   S T U F F ==================}
        ax0 = b#0000110011010111;   dm (SPORT0_Autobuf) = ax0;
        ax0 = 0;    dm (SPORT0_RFSDIV) = ax0;
        ax0 = 0;    dm (SPORT0_SCLKDIV) = ax0;
        ax0 = b#1000011000001111;   dm (SPORT0_Control_Reg) = ax0;
        ax0 = b#0000000000000111;   dm (SPORT0_TX_Channels0) = ax0;
        ax0 = b#0000000000000111;   dm (SPORT0_TX_Channels1) = ax0;
        ax0 = b#0000000000000111;   dm (SPORT0_RX_Channels0) = ax0;
        ax0 = b#0000000000000111;   dm (SPORT0_RX_Channels1) = ax0;

{============== S Y S T E M   A N D   M E M O R Y   S T U F F ==============}
        ax0 = b#0001100000000000;   dm (System_Control_Reg) = ax0;
        ifc = b#00000011111111;         { clear pending interrupt }
        nop;

        icntl = b#00010;
        mstat = b#1000000;

        { ADSP 1847 Codec intialization }
        ax0 = 1;
        dm(stat_flag) = ax0;            { clear flag }
        ena ints;                       { enable transmit interrupt }
        imask = b#0001000000;
        ax0 = dm (i6, m5);              { start interrupt }
        tx0 = ax0;

check_init:
        ax0 = dm (stat_flag);       { wait for entire init }
        af = pass ax0;              { buffer to be sent to }
        if ne jump check_init;      { the codec            }

        ay0 = 2;
check_aci1:
        ax0 = dm (rx_buf);          { once initialized, wait for codec }
        ar = ax0 and ay0;           { to come out of autocalibration }
        if eq jump check_aci1;      { wait for bit set }

check_aci2:
        ax0 = dm (rx_buf);          { wait for bit clear }
        ar = ax0 and ay0;
        if ne jump check_aci2;
        idle;

        ay0 = 0xbf3f;               { unmute left DAC }
        ax0 = dm (init_cmds + 6);
        ar = ax0 AND ay0;
        dm (tx_buf) = ar;
        idle;

        ax0 = dm (init_cmds + 7);   { unmute right DAC }
        ar = ax0 AND ay0;
        dm (tx_buf) = ar;
        idle;
        ifc = b#00000011111111;     { clear any pending interrupt }
        nop;

        l0=0; l1=0; l2=0; l3=0; l4=0; l7=0;

        imask = b#0000100101;       { enable rx0 interrupt }

        i7 = ^signon;
        call sendLine;              { send line to host }

{        jump set_baud_9600;    }

        { set baud rate of serial port to 31250 bps }
set_baud_31250:
.const CRYSTAL_FREQ_IN_kHZ=   16670;    {   Crystal speed related constant. }
.const  MIDIPERIOD = (CRYSTAL_FREQ_IN_kHZ * 2000 / (3 *  31250)) - 1;
        ax0=MIDIPERIOD;                 { autobaud not used }
        dm(TCOUNT)=ax0;
        dm(TPERIOD)=ax0;            { interrupts generated at 3x baudrate }

set_baud_9600:

        jump main_loop;

{ realtime command loop - check for incoming data on serial port }
main_loop:  
        ar   = dm (CHAR_WAITING_FLAG);  { check for incoming MIDI data }
        none = pass ar;
        if eq call process_midi;        { process MIDI byte }
        
        ar   = dm(calc_another);        { check to calc synth sample }
        none = pass ar;
        if ne call calc_synth;

        ax1 = dm(return_to_mon);        { check return to mon }
        ar = tstbit 0 of ax1;
        if ne rts;

        jump main_loop;

{ SPORT0 interrupt handler  (called at 44.1 KHz) }
input_samples:
        ena sec_reg;

        { get and save input }
        ax0 = dm(rx_buf + 1);
        ax1 = dm(rx_buf + 2);
        dm(input1) = ax0;
        dm(input2) = ax1;

        { write last calc'd synth samples to DAC buffer }
        ax0 = dm(synthout1);            
        ax1 = dm(synthout2);            

        {ax0 = dm(input1);}  { debug }
        {ax1 = dm(input2);}  { debug }

        dm(tx_buf + 1) = ax0;
        dm(tx_buf + 2) = ax1;

        { tell main loop it should calc another sample }
        ax0 = 1;
        dm(calc_another)=ax0;

        rti;


{ synthesizer algorithm entry point }
calc_synth:
        set fl2;

        call do_samp;

        dm(synthout1)=mr1;
        dm(synthout2)=mr1;

done_synth:
        { tell main loop we finished calc'ing another sample }
        ax0 = 0;
        dm(calc_another)=ax0;
        
        reset fl2;
        rts;


{ transmit interrupt used for Codec initialization }
next_cmd:
        ena sec_reg;
        ax0 = dm (i3, m1);          { fetch next control word and }
        dm (tx_buf) = ax0;          { place in transmit slot 0    }
        ax0 = i3;
        ay0 = ^init_cmds;
        ar = ax0 - ay0;
        if gt rti;                  { rti if more control words still waiting }
        ax0 = 0xaf00;               { else set done flag and }
        dm (tx_buf) = ax0;          { remove MCE if done initialization }
        ax0 = 0;
        dm (stat_flag) = ax0;       { reset status flag }
        rti;

{ MIDI serial port ISR - actually just enables timer, which
  calls timer interrupt to read the serial port }
irq1isr:
        pop sts;
        ena timer;              { start timer now }
        rts;                    { note rts }

nSend:
        {rts;}
        i4 = dm (PTR_TO_OUT_CHAR);        { send int }
        call (i4);

nwt:
        ar = dm (CHAR_SEND_DONE_FLAG);
        none = pass ar;
        if eq jump nwt;                 { wait for char to go out }

        rts;

.entry      sendLine;




{******************************************************************************
 *
 *  Send null terminated string pointed to by i7 and LF/CR.  ASCII is in
 *  lower 8-bit.
 *
 *  REGISTER USAGE SUMMARY:
 *
 *  input  : i7
 *  modyfy : none
 *  output : none
 *  destroy: i7, m7 = 1, l7 = 0, ax1
 *  keep   : none
 *  memory : out_char_ax1
 *  calls  : none
 *
 ******************************************************************************}

sendLine:
        l7 = 0;
        m7 = 1;
again:
        ax1 = dm (i7, m7);
        none = pass ax1;
        if eq rts;
        call nSend;
        jump again;

        rts;

.endmod;
